<?php
/*
This file has been generated by the Sabai scaffold script. Do not edit this file directly.
If you need to customize the class, use the following file:
pluginsy/Xigg/Model/ViewGateway.php
*/
abstract class Plugg_Xigg_Model_Base_ViewGateway extends Sabai_Model_Gateway
{
    public function getName()
    {
        return 'view';
    }

    public function getFields()
    {
        return array('view_id' => Sabai_Model::KEY_TYPE_INT, 'view_created' => Sabai_Model::KEY_TYPE_INT, 'view_updated' => Sabai_Model::KEY_TYPE_INT, 'view_uid' => Sabai_Model::KEY_TYPE_VARCHAR, 'view_last' => Sabai_Model::KEY_TYPE_INT, 'view_node_id' => Sabai_Model::KEY_TYPE_INT_NULL);
    }

    protected function _getSelectByIdQuery($id, array $fields)
    {
        $fields = empty($fields) ? '*' : implode(', t.', $fields);
        return sprintf('SELECT t.%s FROM %sview t WHERE view_id = %d', $fields, $this->_db->getResourcePrefix(), $id);
    }

    protected function _getSelectByCriteriaQuery($criteriaStr, array $fields)
    {
        $fields = empty($fields) ? '*' : implode(', t.', $fields);
        return sprintf('SELECT t.%1$s FROM %2$sview t WHERE %3$s', $fields, $this->_db->getResourcePrefix(), $criteriaStr);
    }

    protected function _getInsertQuery(array $values)
    {
        $values['view_created'] = time();
        $values['view_updated'] = 0;
        $values['view_node_id'] = !empty($values['view_node_id']) ? intval($values['view_node_id']) : 'NULL';
        return sprintf("INSERT INTO %sview(view_created, view_updated, view_uid, view_last, view_node_id) VALUES(%d, %d, %s, %d, %s)", $this->_db->getResourcePrefix(), $values['view_created'], $values['view_updated'], $this->_db->escapeString($values['view_uid']), $values['view_last'], $values['view_node_id']);
    }

    protected function _getUpdateQuery($id, array $values)
    {
        $values['view_node_id'] = !empty($values['view_node_id']) ? intval($values['view_node_id']) : 'NULL';
        $last_update = $values['view_updated'];
        $values['view_updated'] = time();
        return sprintf("UPDATE %sview SET view_updated = %d, view_uid = %s, view_last = %d, view_node_id = %s WHERE view_id = %d AND view_updated = %d", $this->_db->getResourcePrefix(), $values['view_updated'], $this->_db->escapeString($values['view_uid']), $values['view_last'], $values['view_node_id'], $id, $last_update);
    }

    protected function _getDeleteQuery($id)
    {
        return sprintf('DELETE FROM %1$sview WHERE view_id = %2$d', $this->_db->getResourcePrefix(), $id);
    }

    protected function _getUpdateByCriteriaQuery($criteriaStr, array $sets)
    {
        $sets['view_updated'] = 'view_updated=' . time();
        return sprintf('UPDATE %sview SET %s WHERE %s', $this->_db->getResourcePrefix(), implode(',', $sets), $criteriaStr);
    }

    protected function _getDeleteByCriteriaQuery($criteriaStr)
    {
        return sprintf('DELETE FROM %1$sview WHERE %2$s', $this->_db->getResourcePrefix(), $criteriaStr);
    }

    protected function _getCountByCriteriaQuery($criteriaStr)
    {
        return sprintf('SELECT COUNT(*) FROM %1$sview WHERE %2$s', $this->_db->getResourcePrefix(), $criteriaStr);
    }

    protected function _afterInsertTrigger1($id, array $new)
    {
        if (!empty($new['view_node_id'])) {
            $this->_db->exec(sprintf('UPDATE %snode SET node_view_count = node_view_count + 1, node_view_last = %d, node_view_lasttime = %d WHERE node_id = %d', $this->_db->getResourcePrefix(), $id, $new['view_created'], $new['view_node_id']));
        }
    }

    protected function _afterDeleteTrigger1($id, array $old)
    {
        if (!empty($old['view_node_id'])) {
            $sql = sprintf('SELECT view_id, view_created FROM %sview WHERE view_node_id = %d ORDER BY view_created DESC', $this->_db->getResourcePrefix(), $old['view_node_id']);
            if (($rs = $this->_db->query($sql, 1, 0)) && ($rs->rowCount() > 0)) {
                $row = $rs->fetchAssoc();
                $this->_db->exec(sprintf('UPDATE %snode SET node_view_count = node_view_count - 1, node_view_last = %d, node_view_lasttime = %d WHERE node_id = %d', $this->_db->getResourcePrefix(), $row['view_id'], $row['view_created'], $old['view_node_id']));
            } else {
                $this->_db->exec(sprintf('UPDATE %snode SET node_view_count = node_view_count - 1, node_view_last = 0, node_view_lasttime = node_created WHERE node_id = %d', $this->_db->getResourcePrefix(), $old['view_node_id']));
            }
        }
    }

    protected function _afterUpdateTrigger1($id, array $new, array $old)
    {
        if (empty($old['view_node_id']) && !empty($new['view_node_id'])) {
            $this->_db->exec(sprintf('UPDATE %snode SET node_view_count = node_view_count + 1, node_view_last = %d, node_view_lasttime = %d WHERE node_id = %d', $this->_db->getResourcePrefix(), $id, $new['view_created'], $new['view_node_id']));
        } elseif (!empty($old['view_node_id']) && empty($new['view_node_id'])) {
            $sql = sprintf('SELECT view_id, view_created FROM %sview WHERE view_node_id = %d ORDER BY view_created DESC', $this->_db->getResourcePrefix(), $old['view_node_id']);
            if (($rs = $this->_db->query($sql, 1, 0)) && ($rs->rowCount() > 0)) {
                $row = $rs->fetchAssoc();
                $this->_db->exec(sprintf('UPDATE %snode SET node_view_count = node_view_count - 1, node_view_last = %d, node_view_lasttime = %d WHERE node_id = %d', $this->_db->getResourcePrefix(), $row['view_id'], $row['view_created'], $old['view_node_id']));
            } else {
                $this->_db->exec(sprintf('UPDATE %snode SET node_view_count = node_view_count - 1, node_view_last = 0, node_view_lasttime = node_created WHERE node_id = %d', $this->_db->getResourcePrefix(), $old['view_node_id']));
            }
        } elseif ($old['view_node_id'] != $new['view_node_id']) {
            $sql = sprintf('SELECT view_id, view_created FROM %sview WHERE view_node_id = %d ORDER BY view_created DESC', $this->_db->getResourcePrefix(), $old['view_node_id']);
            if (($rs = $this->_db->query($sql, 1, 0)) && ($rs->rowCount() > 0)) {
                $row = $rs->fetchAssoc();
                $this->_db->exec(sprintf('UPDATE %snode SET node_view_count = node_view_count - 1, node_view_last = %d, node_view_lasttime = %d WHERE node_id = %d', $this->_db->getResourcePrefix(), $row['view_id'], $row['view_created'], $old['view_node_id']));
            } else {
                $this->_db->exec(sprintf('UPDATE %snode SET node_view_count = node_view_count - 1, node_view_last = 0, node_view_lasttime = node_created WHERE node_id = %d', $this->_db->getResourcePrefix(), $old['view_node_id']));
            }
            $this->_db->exec(sprintf('UPDATE %snode SET node_view_count = node_view_count + 1, node_view_last = %d, node_view_lasttime = %d WHERE node_id = %d', $this->_db->getResourcePrefix(), $id, $new['view_created'], $new['view_node_id']));
        }
    }

    protected function _afterInsertTrigger($id, array $new)
    {
        $this->_afterInsertTrigger1($id, $new);
    }

    protected function _afterUpdateTrigger($id, array $new, array $old)
    {
        $this->_afterUpdateTrigger1($id, $new, $old);
    }

    protected function _afterDeleteTrigger($id, array $old)
    {
        $this->_afterDeleteTrigger1($id, $old);
    }
}